#ifndef _GDIPP_EXE
#include "settings.h"
#include <tlhelp32.h>
#include <shlwapi.h>	//DLLVERSIONINFO

// win2kȍ~
#pragma comment(linker, "/subsystem:windows,5.0")

EXTERN_C LRESULT CALLBACK _GetMsgProc(int code, WPARAM wParam, LPARAM lParam)
{
	//Ȃ
	return CallNextHookEx(NULL, code, wParam, lParam);
}

EXTERN_C HRESULT WINAPI GdippDllGetVersion(DLLVERSIONINFO* pdvi)
{
	if (!pdvi || pdvi->cbSize < sizeof(DLLVERSIONINFO)) {
		return E_INVALIDARG;
	}

	const UINT cbSize = pdvi->cbSize;
	ZeroMemory(pdvi, cbSize);
	pdvi->cbSize = cbSize;

	HRSRC hRsrc = FindResource(GetDLLInstance(), MAKEINTRESOURCE(VS_VERSION_INFO), RT_VERSION);
	if (!hRsrc) {
		return E_FAIL;
	}

	HGLOBAL hGlobal = LoadResource(GetDLLInstance(), hRsrc);
	if (!hGlobal) {
		return E_FAIL;
	}

	const WORD* lpwPtr = (const WORD*)LockResource(hGlobal);
	if (lpwPtr[1] != sizeof(VS_FIXEDFILEINFO)) {
		return E_FAIL;
	}

	const VS_FIXEDFILEINFO* pvffi = (const VS_FIXEDFILEINFO*)(lpwPtr + 20);
	if (pvffi->dwSignature != VS_FFI_SIGNATURE ||
			pvffi->dwStrucVersion != VS_FFI_STRUCVERSION) {
		return E_FAIL;
	}

	//8.0.2006.1027
	// -> Major: 8, Minor: 2006, Build: 1027
	pdvi->dwMajorVersion	= HIWORD(pvffi->dwFileVersionMS);
	pdvi->dwMinorVersion	= LOWORD(pvffi->dwFileVersionMS) * 10 + HIWORD(pvffi->dwFileVersionLS);
	pdvi->dwBuildNumber		= LOWORD(pvffi->dwFileVersionLS);
	pdvi->dwPlatformID		= DLLVER_PLATFORM_NT;

	if (pdvi->cbSize < sizeof(DLLVERSIONINFO2)) {
		return S_OK;
	}

	DLLVERSIONINFO2* pdvi2 = (DLLVERSIONINFO2*)pdvi;
	pdvi2->ullVersion		= MAKEDLLVERULL(pdvi->dwMajorVersion, pdvi->dwMinorVersion, pdvi->dwBuildNumber, 2);
	return S_OK;
}


void SetManagerHook(FARPROC pfnFrom, FARPROC pfnTo);
FARPROC WINAPI Hook_GetProcAddress(HINSTANCE hModule, LPCSTR lpProcName);

#include <pshpack1.h>
struct _hook_thunk {
	BYTE	p1;
	DWORD	p2;
	WORD	p3;
	DWORD	p4;
};
#include <poppack.h>

void InstallManagerHook()
{
	SetManagerHook((FARPROC)GetProcAddress, (FARPROC)Hook_GetProcAddress);
}

void RemoveManagerHook()
{
	SetManagerHook((FARPROC)Hook_GetProcAddress, (FARPROC)GetProcAddress);
}

void SetManagerHook(FARPROC pfnFrom, FARPROC pfnTo)
{
#ifdef _WIN64
#error x64ɂ͑ΉĂ܂
#else
	HINSTANCE hinstManager = GetModuleHandle(_T("gdippManager.exe"));
	if (!hinstManager) {
		return;
	}

//__asm int 03h;
TRACE(_T("SetManagerHook(0x%p, 0x%p)\n"), pfnFrom, pfnTo);
	LPBYTE pBase = (LPBYTE)hinstManager;
	PIMAGE_DOS_HEADER pdosh = (PIMAGE_DOS_HEADER)pBase;
	if (pdosh->e_magic != IMAGE_DOS_SIGNATURE) {
		return;
	}

	PIMAGE_NT_HEADERS pnth = (PIMAGE_NT_HEADERS)(pBase + pdosh->e_lfanew);
	if (pnth->Signature != IMAGE_NT_SIGNATURE) {
		return;
	}

	const DWORD offs = pnth->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress;
	const DWORD size = pnth->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].Size;
	if (offs == 0 || size == 0) {
		return;
	}

	HINSTANCE hinstKernel = GetModuleHandleA("kernel32.dll");
	HANDLE hProcess = GetCurrentProcess();
	PIMAGE_IMPORT_DESCRIPTOR pdesc = (PIMAGE_IMPORT_DESCRIPTOR)(pBase + offs);
	for (; pdesc->OriginalFirstThunk != 0; pdesc++) {
		LPCSTR name = (LPCSTR)(pBase + pdesc->Name);
		if (_stricmp(name, "kernel32.dll") != 0) {
			continue;
		}

		DWORD* pIAT = (DWORD*)(pBase + pdesc->FirstThunk);
		for (; *pIAT; pIAT++) {
			const DWORD dwIAT = *pIAT;
			if (dwIAT == (DWORD)pfnFrom) {
				_hook_thunk* p = (_hook_thunk*)VirtualAllocEx(hProcess, NULL, sizeof(_hook_thunk), MEM_COMMIT, PAGE_EXECUTE_READWRITE);
				p->p1 = 0xB8;			//mov eax, pfnTo
				p->p2 = (DWORD)pfnTo;
				p->p3 = 0xE0FF;			//jmp eax
				p->p4 = 0xDeadBeef;

TRACE(_T(" Hook: 0x%p -> 0x%p, @0x%p\n"), pfnFrom, pfnTo, pIAT);
				DWORD org = 0;
				VirtualProtect(pIAT, sizeof(DWORD), PAGE_READWRITE, &org);
				InterlockedExchange((LPLONG)pIAT, (LONG)p);
				VirtualProtect(pIAT, sizeof(DWORD), org, &org);
				FlushInstructionCache(hProcess, p, sizeof(_hook_thunk));
				FlushInstructionCache(hProcess, pIAT, sizeof(DWORD));
			} else if (dwIAT < (DWORD)hinstKernel) {
				_hook_thunk thunk;
				if (!ReadProcessMemory(hProcess, (LPVOID)dwIAT, &thunk, sizeof(_hook_thunk), NULL)
					|| thunk.p4 != 0xDeadBeef
					|| thunk.p2 != (DWORD)pfnFrom) {
						continue;
				}
				_hook_thunk* p = (_hook_thunk*)dwIAT;
				InterlockedExchange((LPLONG)&p->p2, (LONG)pfnTo);
				FlushInstructionCache(hProcess, p, sizeof(_hook_thunk));
			}
		}
	}
#endif
}


FARPROC WINAPI Hook_GetProcAddress(HINSTANCE hModule, LPCSTR lpProcName)
{
	if (hModule != GetDLLInstance() || IS_INTRESOURCE(lpProcName)) {
		return GetProcAddress(hModule, lpProcName);
	}

	DWORD d = 0;
	LPCSTR p = lpProcName;
	while (*p) {
		d <<= (*p & 7);
		d ^= (*p++ - 'A');
	}
	if (d == 2593281362U) {
		return (FARPROC)_GetMsgProc;
	}
	return GetProcAddress(hModule, lpProcName);
}
#endif	//!_GDIPP_EXE


#ifndef Assert
#include <crtdbg.h>
#define Assert	_ASSERTE
#endif	//!Assert

//kernel32pGetProcAddresshL
FARPROC K32GetProcAddress(LPCSTR lpProcName)
{
#ifndef _WIN64
	//nɂ͑ΉȂ
	Assert(!IS_INTRESOURCE(lpProcName));

	//kernel32̃x[XAhX擾
	LPBYTE pBase = (LPBYTE)GetModuleHandleA("kernel32.dll");

	//̕ӂ100%͂Ȃ̂ŃG[`FbNȂ
	PIMAGE_DOS_HEADER pdosh = (PIMAGE_DOS_HEADER)pBase;
	Assert(pdosh->e_magic == IMAGE_DOS_SIGNATURE);
	PIMAGE_NT_HEADERS pnth = (PIMAGE_NT_HEADERS)(pBase + pdosh->e_lfanew);
	Assert(pnth->Signature == IMAGE_NT_SIGNATURE);

	const DWORD offs = pnth->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress;
	const DWORD size = pnth->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].Size;
	if (offs == 0 || size == 0) {
		return NULL;
	}

	PIMAGE_EXPORT_DIRECTORY pdir = (PIMAGE_EXPORT_DIRECTORY)(pBase + offs);
	DWORD*	pFunc = (DWORD*)(pBase + pdir->AddressOfFunctions);
	WORD*	pOrd  = (WORD*)(pBase + pdir->AddressOfNameOrdinals);
	DWORD*	pName = (DWORD*)(pBase + pdir->AddressOfNames);

	for(DWORD i=0; i<pdir->NumberOfFunctions; i++) {
		for(DWORD j=0; j<pdir->NumberOfNames; j++) {
			if(pOrd[j] != i)
				continue;

			if(strcmp((LPCSTR)pBase + pName[j], lpProcName) != 0)
				continue;

			return (FARPROC)(pBase + pFunc[i]);
		}
	}
	return NULL;
#endif
}


#include <pshpack1.h>
class opcode_data {
private:
	BYTE	p1;
#ifdef _DEBUG_MESSAGEBOX
	WORD	dxaa;
	BYTE	dpa1;
	BYTE	dpa2;
	BYTE	dpd;
	LONG	dpdd;
	BYTE	dpa3;
	BYTE	dma;
	LONG	dmad;
	WORD	dc;
	BYTE	dcc;
#endif
	BYTE	p2;
	LONG	p3;
	BYTE	p4;
	LONG	p5;
	WORD	p6;
	BYTE	p7;
	BYTE	p8;
	LONG	p9;
	BYTE	cc;
	//: dllpathWORDEɂȂƏꍇɂĂ͐ɓ삵Ȃ
	WCHAR	dllpath[MAX_PATH];

public:
	opcode_data()
	{
		//int 03hŖ߂
		FillMemory(this, sizeof(*this), 0xcc);
	}
	bool init(LPVOID remoteaddr, LONG orgEIP)
	{
		//WORDE`FbN
		C_ASSERT((offsetof(opcode_data, dllpath) & 1) == 0);

#ifdef _DEBUG_MESSAGEBOX
		//MessageBoxo^C~OVisualC++̃fobKɃA^b`
		dxaa	= 0xC033;	//xor eax, eax
		dpa1	= 0x50;		//push eax
		dpa2	= 0x50;		//push eax
		dpd		= 0x68;		//push dllpath
		dpdd	= (LONG)remoteaddr + offsetof(opcode_data, dllpath);
		dpa3	= 0x50;		//push eax
		dma		= 0xB8;		//mov eax, MessageBoxW
		dmad	= (LONG)MessageBoxW;
		dc		= 0xD0FF;	//call eax
		dcc		= 0x90;		//nop
#endif

		//ȂGetProcAddressLoadLibraryW̃AhXȂƂ̂
		//kernel32̃wb_玩OŎ擾
		FARPROC pfn = K32GetProcAddress("LoadLibraryW");
		if(!pfn)
			return false;

		p1	= 0x60;		//pushad
		p2	= 0x68;		//push dllpath
		p3	= (LONG)remoteaddr + offsetof(opcode_data, dllpath);
		p4	= 0xB8;		//mov eax, LoadLibraryW
		p5  = (LONG)pfn;
		p6	= 0xD0FF;	//call eax
		p7	= 0x61;		//popad
		p8	= 0xE9;		//jmp original_EIP
		p9  = orgEIP - ((LONG)remoteaddr + offsetof(opcode_data, cc));
		// gdi++.dll̃pX
		return !!GetModuleFileNameW(GetDLLInstance(), dllpath, MAX_PATH);
	}
};
#include <poppack.h>

// ~߂ĂvZXLoadLibraryR[h𒍓
EXTERN_C BOOL WINAPI GdippInjectDLL(const PROCESS_INFORMATION* ppi)
{
	CONTEXT ctx = { 0 };
	ctx.ContextFlags = CONTEXT_CONTROL;
	//CREATE_SUSPENDEDȂ̂Ŋ{Iɐ͂
	if(!GetThreadContext(ppi->hThread, &ctx))
		return false;

	opcode_data local;
	opcode_data* remote = (opcode_data*)VirtualAllocEx(ppi->hProcess, NULL, sizeof(opcode_data), MEM_COMMIT, PAGE_EXECUTE_READWRITE);
	if(!remote)
		return false;

	if(!local.init(remote, ctx.Eip)
		|| !WriteProcessMemory(ppi->hProcess, remote, &local, sizeof(opcode_data), NULL)) {
			VirtualFreeEx(ppi->hProcess, remote, 0, MEM_RELEASE);
			return false;
	}

	FlushInstructionCache(ppi->hProcess, remote, sizeof(opcode_data));
	ctx.Eip = (DWORD)remote;
	return !!SetThreadContext(ppi->hThread, &ctx);
}
